var ROLBappInfo = Components.classes["@mozilla.org/xre/app-info;1"]
					.getService(Components.interfaces.nsIXULAppInfo);
var ROLBversionChecker = Components.classes["@mozilla.org/xpcom/version-comparator;1"]
					.getService(Components.interfaces.nsIVersionComparator);

if (ROLBversionChecker.compare(ROLBappInfo.version, "4.0") >= 0) {
	// CODE FOR FIREFOX 4.0
	nsBrowserAccess.prototype.openURI = function(aURI, aOpener, aWhere, aContext) {
		var newWindow = null;
		var isExternal = (aContext == Ci.nsIBrowserDOMWindow.OPEN_EXTERNAL);

		if (isExternal && aURI && aURI.schemeIs("chrome")) {
			dump("use -chrome command-line option to load external chrome urls\n");
			return null;
		}
	
		// This value must be forced to true, because otherwise the tabs are not visible
		if (! gPrefService.getBoolPref("dom.disable_window_open_feature.toolbar"))
			gPrefService.setBoolPref("dom.disable_window_open_feature.toolbar", true);

		if (aWhere == Ci.nsIBrowserDOMWindow.OPEN_DEFAULTWINDOW)
			aWhere = gPrefService.getIntPref("browser.link.open_newwindow");
		switch (aWhere) {
		  case Ci.nsIBrowserDOMWindow.OPEN_NEWWINDOW :
				// FIXME: Bug 408379. So how come this doesn't send the
				// referrer like the other loads do?
				var url = aURI ? aURI.spec : "about:blank";
				// Pass all params to openDialog to ensure that "url" isn't passed through
				// loadOneOrMoreURIs, which splits based on "|"
			newWindow = openDialog(getBrowserURL(), "_blank", "all,dialog=no", url, null, null, null);
			break;
		  case Ci.nsIBrowserDOMWindow.OPEN_NEWTAB :
			let win, needToFocusWin;
			//  MODIFIED PART BEGINNING
			/*
		        // try the current window.  if we're in a popup, fall back on the most recent browser window
		        if (!window.document.documentElement.getAttribute("chromehidden"))
			          win = window;
		        else {
			          win = Cc["@mozilla.org/browser/browserglue;1"]
		                  .getService(Ci.nsIBrowserGlue)
		                  .getMostRecentBrowserWindow();
		          needToFocusWin = true;
			        }
			}*/
		
			win = window;
			//  MODIFIED PART END

			if (!win) {
				// we couldn't find a suitable window, a new one needs to be opened.
				return null;
			}

			/*if (isExternal && (!aURI || aURI.spec == "about:blank")) {
				win.BrowserOpenTab(); // this also focuses the location bar
          			win.focus();
				newWindow = win.content;
				break;
			}*/

        let loadInBackground = gPrefService.getBoolPref("browser.tabs.loadDivertedInBackground");
        let referrer = aOpener ? makeURI(aOpener.location.href) : null;

        let tab = win.gBrowser.loadOneTab(aURI ? aURI.spec : "about:blank", {
                                          referrerURI: referrer,
                                          fromExternal: isExternal,
                                          inBackground: loadInBackground});
        let browser = win.gBrowser.getBrowserForTab(tab);

        newWindow = browser.contentWindow;
        if (needToFocusWin || (!loadInBackground && isExternal))
          newWindow.focus();
        break;
      default : // OPEN_CURRENTWINDOW or an illegal value
        newWindow = content;
        if (aURI) {
          let referrer = aOpener ? makeURI(aOpener.location.href) : null;
          let loadflags = isExternal ?
                            Ci.nsIWebNavigation.LOAD_FLAGS_FROM_EXTERNAL :
                            Ci.nsIWebNavigation.LOAD_FLAGS_NONE;
          gBrowser.loadURIWithFlags(aURI.spec, loadflags, referrer, null, null);
        }
        if (!gPrefService.getBoolPref("browser.tabs.loadDivertedInBackground"))
          content.focus();
    }
    return newWindow;
  };
}
else if (ROLBversionChecker.compare(ROLBappInfo.version, "3.6") >= 0) {
	// CODE FOR FIREFOX 3.6

  nsBrowserAccess.prototype.openURI = function(aURI, aOpener, aWhere, aContext) {
	var newWindow = null;
	var isExternal = (aContext == Ci.nsIBrowserDOMWindow.OPEN_EXTERNAL);

	if (isExternal && aURI && aURI.schemeIs("chrome")) {
		dump("use -chrome command-line option to load external chrome urls\n");
		return null;
	}

	var loadflags = isExternal ?
                       Ci.nsIWebNavigation.LOAD_FLAGS_FROM_EXTERNAL :
                       Ci.nsIWebNavigation.LOAD_FLAGS_NONE;
	if (aWhere == Ci.nsIBrowserDOMWindow.OPEN_DEFAULTWINDOW)
		aWhere = gPrefService.getIntPref("browser.link.open_newwindow");
	switch (aWhere) {
		case Ci.nsIBrowserDOMWindow.OPEN_NEWWINDOW :
		// FIXME: Bug 408379. So how come this doesn't send the
		// referrer like the other loads do?
		var url = aURI ? aURI.spec : "about:blank";
		// Pass all params to openDialog to ensure that "url" isn't passed through
		// loadOneOrMoreURIs, which splits based on "|"
		newWindow = openDialog(getBrowserURL(), "_blank", "all,dialog=no", url, null, null, null);
		break;
	case Ci.nsIBrowserDOMWindow.OPEN_NEWTAB :
		let win, needToFocusWin;
		
		//  MODIFIED PART BEGINNING
		/*
		// try the current window.  if we're in a popup, fall back on the most recent browser window
		if (!window.document.documentElement.getAttribute("chromehidden"))
			win = window;
		else {
			win = Cc["@mozilla.org/browser/browserglue;1"]
			.getService(Ci.nsIBrowserGlue)
			.getMostRecentBrowserWindow();
			needToFocusWin = true;
		}*/
	
		win = window;
		//  MODIFIED PART END
	
		if (!win) {
			// we couldn't find a suitable window, a new one needs to be opened.
			return null;
		}

		let loadInBackground = gPrefService.getBoolPref("browser.tabs.loadDivertedInBackground");
		let referrer = aOpener ? makeURI(aOpener.location.href) : null;

        // If this is an external load, we need to load a blank tab first,
        // because loadflags can't be passed to loadOneTab.
        let loadBlankFirst = !aURI || isExternal;
        let tab = win.gBrowser.loadOneTab(loadBlankFirst ? "about:blank" : aURI.spec,
                                          referrer, null, null, loadInBackground, false);
        let browser = win.gBrowser.getBrowserForTab(tab);

        if (loadBlankFirst && aURI)
          browser.loadURIWithFlags(aURI.spec, loadflags, referrer, null, null);

        newWindow = browser.contentWindow;
        if (needToFocusWin || (!loadInBackground && isExternal))
          newWindow.focus();
        break;
      default : // OPEN_CURRENTWINDOW or an illegal value
        newWindow = content;
        if (aURI) {
          let referrer = aOpener ? makeURI(aOpener.location.href) : null;
          gBrowser.loadURIWithFlags(aURI.spec, loadflags, referrer, null, null);
        }
        if (!gPrefService.getBoolPref("browser.tabs.loadDivertedInBackground"))
          content.focus();
    }
    return newWindow;
  };
}

else if (ROLBversionChecker.compare(ROLBappInfo.version, "3.5") >= 0) {
	// CODE FOR FIREFOX 3.5

  nsBrowserAccess.prototype.openURI = function(aURI, aOpener, aWhere, aContext) {
	var newWindow = null;
    var referrer = null;
    var isExternal = (aContext == Ci.nsIBrowserDOMWindow.OPEN_EXTERNAL);

    if (isExternal && aURI && aURI.schemeIs("chrome")) {
      dump("use -chrome command-line option to load external chrome urls\n");
      return null;
    }

    var loadflags = isExternal ?
                       Ci.nsIWebNavigation.LOAD_FLAGS_FROM_EXTERNAL :
                       Ci.nsIWebNavigation.LOAD_FLAGS_NONE;
    var location;
    if (aWhere == Ci.nsIBrowserDOMWindow.OPEN_DEFAULTWINDOW)
      aWhere = gPrefService.getIntPref("browser.link.open_newwindow");
    switch (aWhere) {
      case Ci.nsIBrowserDOMWindow.OPEN_NEWWINDOW :
        // FIXME: Bug 408379. So how come this doesn't send the
        // referrer like the other loads do?
        var url = aURI ? aURI.spec : "about:blank";
        // Pass all params to openDialog to ensure that "url" isn't passed through
        // loadOneOrMoreURIs, which splits based on "|"
        newWindow = openDialog(getBrowserURL(), "_blank", "all,dialog=no", url, null, null, null);
        break;
      case Ci.nsIBrowserDOMWindow.OPEN_NEWTAB :
        let win, needToFocusWin;

		//  MODIFIED PART BEGINNING
		/*
		// try the current window.  if we're in a popup, fall back on the most recent browser window
			if (!window.document.documentElement.getAttribute("chromehidden"))
			win = window;
			else {
			var browserGlue = Cc[GLUE_CID].getService(Ci.nsIBrowserGlue);
			win = browserGlue.getMostRecentBrowserWindow();
			needToFocusWin = true;
			}*/
		
		win = window;

		//  MODIFIED PART END
		
        if (!win) {
          // we couldn't find a suitable window, a new one needs to be opened.
          return null;
        }
        var loadInBackground = gPrefService.getBoolPref("browser.tabs.loadDivertedInBackground");
        var newTab = win.gBrowser.loadOneTab("about:blank", null, null, null, loadInBackground, false);
        newWindow = win.gBrowser.getBrowserForTab(newTab).docShell
                                .QueryInterface(Ci.nsIInterfaceRequestor)
                                .getInterface(Ci.nsIDOMWindow);
        try {
          if (aURI) {
            if (aOpener) {
              location = aOpener.location;
              referrer =
                      Components.classes["@mozilla.org/network/io-service;1"]
                                .getService(Components.interfaces.nsIIOService)
                                .newURI(location, null, null);
            }
            newWindow.QueryInterface(Ci.nsIInterfaceRequestor)
                     .getInterface(Ci.nsIWebNavigation)
                     .loadURI(aURI.spec, loadflags, referrer, null, null);
          }
          if (needToFocusWin || (!loadInBackground && isExternal))
            newWindow.focus();
        } catch(e) {
        }
        break;
      default : // OPEN_CURRENTWINDOW or an illegal value
        try {
          if (aOpener) {
            newWindow = aOpener.top;
            if (aURI) {
              location = aOpener.location;
              referrer =
                      Components.classes["@mozilla.org/network/io-service;1"]
                                .getService(Components.interfaces.nsIIOService)
                                .newURI(location, null, null);

              newWindow.QueryInterface(Ci.nsIInterfaceRequestor)
                       .getInterface(nsIWebNavigation)
                       .loadURI(aURI.spec, loadflags, referrer, null, null);
            }
          } else {
            newWindow = gBrowser.selectedBrowser.docShell
                                .QueryInterface(Ci.nsIInterfaceRequestor)
                                .getInterface(Ci.nsIDOMWindow);
            if (aURI) {
              gBrowser.loadURIWithFlags(aURI.spec, loadflags, null, 
                                        null, null);
            }
          }
          if(!gPrefService.getBoolPref("browser.tabs.loadDivertedInBackground"))
            content.focus();
        } catch(e) {
        }
    }
    return newWindow;
  };
}

else {
	// CODE FOR FIREFOX 3.0
	nsBrowserAccess.prototype._getMostRecentBrowserWindow = function() {
		return window;
	};
}




